<script>
import preset from "@/utils/questionConfigPreset";
import QuestionWrapper from "@/components/Question/QuestionWrapper";
import QUESTION_TYPES from '@/utils/question_types.js';
import Validatable from '@/mixins/Validatable.js';

export default {
  components: {
    QuestionWrapper,
  },
  mixins: [Validatable],
  props: {
    questionId: {
      type: [Number, String],
      default: () => null,
    },
    question: {
      type: Object,
      default: () => null,
    },
    questionType: Boolean,
    default: () => null,
  },
  data() {
    return {
      id: this.question?.id || null,
      title: this.question?.title || '',
      type: this.question?.type || null,
      result: this.question?.result || null,
      variants: this.question?.variants || [],
      condition: this.question?.condition || {},
      text: this.question?.text || '',
      point: this.question?.point || 1,
      QUESTION_TYPES,
    }
  },
  watch: {
    question: {
      deep: true,
      handler(v) {
        if (v) {
          this.reset();
          const { 
            id,
            title,
            type,
            result,
            variants,
            condition,
            value,
            point
           } = v;
          this.id = id;
          this.title = title;
          this.type = type;
          this.result = result;
          this.variants = variants;
          this.condition = condition;
          this.value = value;
          this.point = point;
        } else {
          this.reset();
        }
      }
    }
  },
  computed: {
    fullQuestionComponentType() {
      return this.type ? `question-type-${this.type}` : null;
    }
  },
  methods: {
    reset() {
      this.id = null;
      this.title = null;
      this.type = null;
      this.result = {};
      this.variants = [];
      this.value = null;
      this.condition = null;
      this.point = 1;
    },
    async saveHandle() {
      const isValid = await this.$refs.observer.validate();

      if (!isValid) {
        return;
      }
      const { id, title, type, result, variants, value, condition, point } = this;
      
      if (id) {
      
        this.$emit('edit-question', { id, title, type, result, variants, value, condition, point });
        return;
      }

      this.$emit("create-question", { title, type, result, variants, value, condition, point });
    },
    cancelHandle() {
      this.$emit('cancel');
      this.reset()
    },
    mutateQuestionFields(v) {
      Object.entries(v).forEach(([key, value]) => this[key] = value)
    }
  }
};
</script>
<template>
  <div style="max-width: 400px;">
    <ValidationObserver tag="form" ref="observer">
<!-- 
      <ValidationProvider name="name" rules="required" v-slot="{ errors }">
        <v-text-field
          v-model="title"
          label="Введите название вопроса"
          :error-messages="errors"
        />
      </ValidationProvider> -->
      <ValidationProvider name="text" rules="required" v-slot="{ errors }">
        <v-textarea
          v-model="condition.text"
          label="Введите текст вопроса"
          :error-messages="errors"
        />
      </ValidationProvider>
      <ValidationProvider name="selectedQuestionType" rules="required" v-slot="{ errors }">
        <v-select
          v-model="type"
          label="Выберете тип теста"
          :items="QUESTION_TYPES"
          :error-messages="errors"
        />
      </ValidationProvider>
      <QuestionWrapper
        v-bind="{ result, variants, condition, type }"
        @input="mutateQuestionFields"
      />
      <ValidationProvider name="point" rules="required" v-slot="{ errors }">
        <v-text-field
          v-model.number="point"
          type="number"
          label="Количество баллов за вопрос"
          :error-messages="errors"
        />
      </ValidationProvider>
    </ValidationObserver>
    <v-btn @click="saveHandle" class="success">Сохранить</v-btn>
    <v-btn @click="cancelHandle" color="red ml-3">Отменить</v-btn>
  </div>
</template>
